﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NUnit.Framework;

namespace BankAccountExample
{
    [TestFixture]
    class CreditAccountTest
    {
        [SetUp]
        public void initialise()
        {
        }

        [Test]
        public void testBalanceIsZero()
        {
            CreditAccount acc = new CreditAccount(0.0);
            Assert.That(acc.getBalance(), Is.EqualTo(0.0));
        }

        [Test]
        public void testBalanceIncreases()
        {
            CreditAccount acc = new CreditAccount(0.0);
            acc.credit(75);

            Assert.That(acc.getBalance(), Is.EqualTo(75.00));
        }

        [Test]
        public void testBalanceDecreases()
        {
            CreditAccount acc = new CreditAccount(100.00);
            acc.debit(35);

            Assert.That(acc.getBalance(), Is.EqualTo(65.00));
        }

        [Test]
        public void testBalanceDoesNotChange()
        {
            CreditAccount acc = new CreditAccount(35.00);
            try
            {
                acc.debit(60);
            }
            catch (InsufficientFunds)
            { }

            Assert.That(acc.getBalance(), Is.EqualTo(35.00));
        }

    }
}
