﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BuisnessObjectToTest;
using NUnit.Framework;

namespace PersonTestWithNUnit
{
    [TestFixture]
    class PersonNUnitTest
    {
        Person selvyn1;
        Person selvyn2;
        Person selvyn3;
        Person samuel;
        Person letitia;

        [SetUp]
        protected void SetUp()
        {
            selvyn1 = new Person("Selvyn", "Wright", 51);
            selvyn2 = new Person("Selvyn", "Wright", 51);
            selvyn3 = new Person("Selvyn", "Wright", 52);
            samuel = new Person("Samuel", "Wright", 24);
            letitia = new Person("Letitia", "Wright", 19);
        }

        [Test, Category("Simple Unit Test")]
        public void testPersonsEqualSameObjects()
        {
            System.Console.WriteLine("testPersonsEqual");

            Assert.AreEqual(true, (selvyn1==selvyn1), "They should be the same");
        }

        [Test, Category("Simple Unit Test")]
        public void testPersonsEqualDifferentObjects()
        {
            System.Console.WriteLine("testPersonsEqual");

            Assert.AreEqual(true, (selvyn1 == selvyn2), "They should be the same");
        }

        [Test, Category("Simple Unit Test")]
        public void testPersonsNotEqualDifferentObjects()
        {
            System.Console.WriteLine("testPersonsNotEqual");

            Assert.AreEqual(true, (selvyn1 != samuel), "They should be the same");
        }


        [Test, Category("Simple Unit Test")]
        public void testPersonsNotEqualOnAge()
        {
            System.Console.WriteLine("testPersonsNotEqual");

            Assert.AreEqual(true, (selvyn1 != selvyn3), "They should not be the same");
        }

        [Test, Category("Simple Unit Test")]
        public void testPersonsAgeLessThan()
        {
            System.Console.WriteLine("testPersonsAgeLessThan");

            Assert.AreEqual(true, (selvyn1.CompareTo(samuel) > 0), "Selvyn should be older than Samuel");
        }

        [Test, Category("Simple Unit Test")]
        public void testPersonsGreaterThan()
        {
            System.Console.WriteLine("testPersonsGreaterThan");

            Assert.AreEqual(true, (letitia.CompareTo(samuel) < 0), "Letitia should be younger than Samuel");
        }
    }
}
