﻿
namespace TDD.Mocking
{
    // Osherove, section 3.4 "Refactoring our design to be more testable"
    // 3. Receive an interface before the method call - a) use a factory class
    // Note that rather than the dependency being injected externally, the class under test
    // initiates the request for the dependency
    public class OrderReader2
    {
        private IFileReader _fileReader;
        public OrderReader2()
        {
            _fileReader = FileReaderFactory.Create();
        }

        public Order ReadOrder()
        {
            _fileReader.FileName = "record.csv";
            string line = _fileReader.ReadLine();
            _fileReader.Close();
            string[] details = line.Split(new char[] { ',' });
            int id = int.Parse(details[0]);
            string cust = details[1];
            double price = double.Parse(details[2]);
            Order order = new Order(id, cust, price);
            return order;
        }
    }
}
