﻿Namespace TDD.Mocking
    ' Used by OrderReader2 
    '
    '    "This method is easy. Add a setter to the factory and set it to a fake
    '     dependency of your choice. There’s no changing of the semantics of
    '     the code base, everything stays the same, and the code is dead simple.
    '     The only con is that this method requires that you understand
    '     who calls the factory and when, which means you need to do some
    '     research before you can implement this easily." Osherove, p. 70
    '     

    Public Class FileReaderFactory
        Private Shared _fileReader As IFileReader = New FileReader()

        Public Shared Function Create() As IFileReader
            Return _fileReader
        End Function

        Public Shared Sub SetReader(fileReader_ As IFileReader)
            _fileReader = fileReader_
        End Sub

    End Class
End Namespace
