﻿Namespace TDD.Mocking
    ' Osherove, section 3.4 "Refactoring our design to be more testable"
    ' 3. Receive an interface before the method call - a) use a factory class
    ' Note that rather than the dependency being injected externally, the class under test
    ' initiates the request for the dependency
    Public Class OrderReader2
        Private _fileReader As IFileReader
        Public Sub New()
            _fileReader = FileReaderFactory.Create()
        End Sub

        Public Function ReadOrder() As Order
            _fileReader.FileName = "record.csv"
            Dim line As String = _fileReader.ReadLine()
            _fileReader.Close()
            Dim details As String() = line.Split(New Char() {","c})
            Dim id As Integer = Integer.Parse(details(0))
            Dim cust As String = details(1)
            Dim price As Double = Double.Parse(details(2))
            Dim order As New Order(id, cust, price)
            Return order
        End Function
    End Class
End Namespace
