﻿Namespace TDD.Mocking
    ' Osherove, section 3.4 "Refactoring our design to be more testable"
    ' 3. Receive an interface before the method call - b) use a local factory method
    ' i.e. get an instance of an object just before you do any operations with it
    ' "Extract & override"
    ' variant on the factory class approach, but even simpler 
    Public Class OrderReader3
        ' local virtual factory method 
        Protected Overridable Function GetReader() As IFileReader
            Return New FileReader()
        End Function

        Public Function ReadOrder() As Order
            Dim fileReader As IFileReader = GetReader()
            fileReader.FileName = "record.csv"
            Dim line As String = fileReader.ReadLine()
            fileReader.Close()
            Dim details As String() = line.Split(New Char() {","c})
            Dim id As Integer = Integer.Parse(details(0))
            Dim cust As String = details(1)
            Dim price As Double = Double.Parse(details(2))
            Dim order As New Order(id, cust, price)
            Return order
        End Function
    End Class
End Namespace
