﻿Imports NUnit.Framework
Imports NMock2
Imports [Is] = NUnit.Framework.Is


Namespace TDD.Mocking
    <TestFixture()> _
    Class OrderReaderNMock2Test
        <Test()> _
        Public Sub TestReadOrder()
            Dim mockery = New Mockery()
            Dim mockFileReader = DirectCast(mockery.NewMock(GetType(IFileReader)), IFileReader)
            Expect.Once.On(mockFileReader).SetProperty("FileName").To("record.csv")
            Expect.Once.On(mockFileReader).Method("ReadLine").WithNoArguments().Will([Return].Value("272,ABC,543.21"))
            Expect.Once.On(mockFileReader).Method("Close").WithNoArguments()

            Dim orderReader As New OrderReader(mockFileReader)
            Dim order As Order = orderReader.ReadOrder()
            mockery.VerifyAllExpectationsHaveBeenMet()

            Assert.That(order.OrderId, [Is].EqualTo(272))
            Assert.That(order.Customer, [Is].EqualTo("ABC"))
            Assert.That(order.Price, [Is].EqualTo(543.21))
        End Sub
    End Class
End Namespace
