﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TimeSheetFramework
{
    public  class Timesheet
    {
        private String itsCheckInTime;
        private String itsCheckOutTime;
        private String itsCheckInTimeNormalized = "NIL";
        private String itsCheckOutTimeNormalized = "NIL";
        private double rate;
        private double itsHoursWorked = 0;
        private TimeFormatter timefx = new TimeFormatter();

        public String getCheckInTimeNormalized()
        {
            return itsCheckInTimeNormalized;
        }

        public String getCheckOutTimeNormalized()
        {
            return itsCheckOutTimeNormalized;
        }
    
        public void setCheckInTime(String checkintime)
        {
            this.itsCheckInTime = checkintime;
            try
            {
                itsCheckInTimeNormalized = timefx._format(itsCheckInTime);
            } 
            catch (BadlyFormedTime ex)
            {
                itsCheckInTimeNormalized = timefx.getTokens()[0];
            }
        }

        public void setCheckOutTime(String checkouttime)
        {
            this.itsCheckOutTime = checkouttime;
            try
            {
                itsCheckOutTimeNormalized = timefx._format(itsCheckOutTime);
            } 
            catch (BadlyFormedTime ex)
            {
                itsCheckOutTimeNormalized = timefx.getTokens()[0];
            }
        }

        public void setHourlyRate(String rate)
        {
            this.rate = Double.Parse(rate);
        }
    
        public  String  CheckInTimeNormalized()
        {
            return itsCheckInTimeNormalized;
        }

        public  String  CheckOutTimeNormalized()
        {
            return itsCheckOutTimeNormalized;
        }

        public String Pay()
        {
            if (itsHoursWorked > 0)
                return "NIL";
            else
                return (rate * itsHoursWorked).ToString("0.00");
        }

        public  String  HoursWorked()
        {
            if (itsHoursWorked < 0)
                return "ERR";
            else
                return (itsHoursWorked).ToString("0.00");
        }
        //returns the number of hours worked
        public double calculateHoursWorked()
        {
            WorkCalculator wc = new WorkCalculator();

            if (itsCheckInTimeNormalized.Equals("ERR") || itsCheckOutTimeNormalized.Equals("ERR"))
                itsHoursWorked = 0;
            else
                itsHoursWorked = wc.calculateHoursWorked(itsCheckInTimeNormalized, itsCheckOutTimeNormalized);
        
            return itsHoursWorked;
        }
    
        public  void    execute()
        {
            calculateHoursWorked();
        }
    }
}
